package solution_exercises;

public class Ex6
/*
 * exercise 6. (dice-game) 
 * Write a dice-rolling program. 
 * 1. Use an array to hold dices. 
 * Roll the dices. 
 * 
 * a. Write a method that prints the number of the
 * different values, corresponding to: 
 * 1s: 0 2s: 2 3s: 0 4s: 1 5s: 1 6s: 1
 * 
 * b. Write a method, that test for Yatzy (i.e. all dices shows the 
 * same value)
 * ) and returns the value of the 'eye' composing the yatzy (1..6), in case of,
 * 0 otherwise.
 * 
 * 2. Give the program 10000 dices. Is the random-function working correct?
 */

{
	private Dice[] dices;
	private int[] frequence;

	public Ex6()
	{
		dices = new Dice[5];
		frequence = new int[6];

		for (int i = 0; i < dices.length; i++)
			dices[i] = new Dice();
	}

	private void rollDices()
	{
		for (Dice d : dices)
			d.roll();
	}

	public void testRandom(){
		dices = new Dice[10000];
		for (int i = 0; i < dices.length; i++)
			dices[i] = new Dice();
		rollDices();
		faceCount();
	}
	
	public void faceCount()
	{
		//initialize counter's
		for (int i = 0; i < frequence.length; i++)
			frequence[i] = 0;
		
		//Count the occurences of face-values for all dices
		for (Dice d : dices)
			frequence[d.getFace() - 1]++;

		//Display the result
		for (int i = 0; i < frequence.length; i++)
			System.out.println((i + 1) + "\'s : " + frequence[i]);
	}

	//return kind of Yatzy (1,2,3,4,5 og 6) - 0, in no yatzy
	public int yatzy(){
		boolean isYatzy=true;
		int val=dices[0].getFace();
		int index=1;
		
		while (isYatzy && index<dices.length){
			int currentFaceValue=dices[index++].getFace();
			isYatzy= (val==currentFaceValue);
		}
				
		if(!isYatzy)
			val=0;
		return val;
	}
	
	public static void main(String[] args)
	{
		Ex6 e=new Ex6();
		e.rollDices();
		e.faceCount();
		System.out.println("Yatzy: "+e.yatzy());
		System.out.println("Randomtest:");
		e.testRandom();
	}
}
