package solution_exercises;

import java.util.ArrayList;

public class Ex7
{
	private ArrayList<Dice> dices;
	private ArrayList<Integer> frequence;

	public Ex7()
	{
		dices = new ArrayList<Dice>();

		for (int i = 0; i < 5; i++)
			dices.add(new Dice());
	}

	private void rollDices()
	{
		for (Dice d : dices)
			d.roll();
	}

	public void testRandom(){
		dices = new ArrayList<Dice>();
		for (int i = 0; i < 1000; i++)
			dices.add(new Dice());
		rollDices();
		faceCount();
	}
	
	public void faceCount()
	{
		frequence = new ArrayList<Integer>();
		for (int i = 0; i < 6; i++)
			frequence.add(0);
		
		for (Dice d : dices){
			int face=d.getFace();
			frequence.set(face-1,frequence.get(face-1)+ 1);
		}
		
		
		for (int i = 0; i < frequence.size(); i++)
			System.out.println((i + 1) + "\'s : " + frequence.get(i));
	}

	public int yatzy(){
		boolean isYatzy=true;
		int val=dices.get(0).getFace();
		int index=1;
		while (isYatzy && index<dices.size())
			isYatzy=(val==dices.get(index++).getFace());
		if(!isYatzy)
			val=0;
		return val;
	}
	public static void main(String[] args)
	{
		Ex7 e=new Ex7();
		e.rollDices();
		e.faceCount();
		System.out.println("Yatzy: "+e.yatzy());
		System.out.println("Randomtest:");
		e.testRandom();
	}
}
